/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_BITMAP_H
#define __EBI_BITMAP_H

#include "ebi_config.h"

__EBI_BEGIN_NAMESPACE

class Bitmap
{
 public:
  Bitmap ();
  virtual ~Bitmap ();

  void clear ();
  int getWidth () const;
  int getHeight () const;
  bool convertJpeg (const char* bytes, int length);
  bool convertBitmap (const char* bytes, int length);
  void draw (GID gid, W x, W y);

 private:
  BMP m_bmp;
  CSPEC m_cspec;
};

__EBI_END_NAMESPACE

#endif /* __EBI_BITMAP_H */
