/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_CONTAINER_H
#define __EBI_CONTAINER_H

#include "ebi_config.h"
#include "ebi_element.h"

__EBI_BEGIN_NAMESPACE

class Container : public Element
{
 public:
  Container ();
  virtual ~Container ();

  virtual W getWidth () const;
  virtual W updateSize (Device* device);
  virtual void updateLayout (PNT* pos, W max);
  virtual void draw (Device* device, W low, W high);
  virtual const Reference* getReference (const PNT& pnt) const;
  virtual bool isHit (const PNT& pnt) const;
  virtual void getString (String* str) const;

  void clear ();
  void addElement (Element * element);

 protected:
  Elements m_elements;
  W m_width;
  W m_height;
  W m_low;
  W m_high;
};

__EBI_END_NAMESPACE

#endif /* __EBI_CONTAINER_H */
