/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_ELEMENT_H
#define __EBI_ELEMENT_H

#include "ebi_config.h"
#include "ebi_string.h"

__EBI_BEGIN_NAMESPACE

class Device;
class Reference;

class Element
{
 public:
  Element ();
  virtual ~Element ();

  virtual W getWidth () const = 0;
  virtual W updateSize (Device* device) = 0;
  virtual void updateLayout (PNT* pos, W max) = 0;
  virtual void draw (Device* device, W low, W high) = 0;
  virtual const Reference* getReference (const PNT& pnt) const;
  virtual bool isHit (const PNT& pnt) const = 0;
  virtual void getString (String* str) const = 0;
};

typedef std::list<Element*> Elements;

__EBI_END_NAMESPACE

#endif /* __EBI_ELEMENT_H */
