/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_FUSEN_H
#define __EBI_FUSEN_H

#include "ebi_config.h"
#include "ebi_book.h"

__EBI_BEGIN_NAMESPACE

class Fusen
{
 public:
  Fusen ();
  virtual ~Fusen ();

  void read (MESSAGE * msg);
  void *write (MESSAGE * msg);
  bool getFullview () const;
  void setFullview (bool bFullview);
  const RECT& getWindowRect () const;
  void setWindowRect (const RECT & rect);
  Book::SearchMethod getSearchMethod () const;
  void setSearchMethod (Book::SearchMethod search);

 private:
  typedef struct
  {
    UH size;		// ¤Υ
    H dummy1;		// ߡ
    W dummy2;		// ߡ
    W dummy3;		// ߡ
    H search;		// ˡ
    H bFullview;	// ɽ
    RECT rect;		// ɽ
  }
  Data;

 private:
  Data m_data;

 private:
  static Data *readFile (M_EXECREQ * exec, Data * data);
};

__EBI_END_NAMESPACE

#endif /* __EBI_FUSEN_H */
