/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_KEYWORDPANEL_H
#define __EBI_KEYWORDPANEL_H

#include "ebi_config.h"
#include "ebi_panel.h"
#include "ebi_book.h"
#include "ebi_string.h"
#include "ebi.h"

__EBI_BEGIN_NAMESPACE

class KeywordPanel : public Panel
{
 public:
  enum
  {
    PNL_TB_KEYWORD = 1,
    PNL_WS_METHOD,
    PNL_MS_EXIT,
    PNL_MS_SET,
  };

  KeywordPanel ();
  virtual ~KeywordPanel ();

 public:
  Book::SearchMethod getSearchMethod ();
  void setSearchMethod (Book::SearchMethod search);
  void getKeyword (String * str);
  void setKeyword (const String & str);

 protected:
  virtual bool onBeforeCreate ();
  virtual W onCommand (W ino, W value);

 private:
  TC m_keyword[EB_MAX_WORD_LENGTH + 1];
  Book::SearchMethod m_search;
  
  W onMsSet (W ino, W value);
};

__EBI_END_NAMESPACE

#endif /* __EBI_KEYWORDPANEL_H */
