/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001-2002  HASEGAWA Masafumi
 */

#ifndef __EBI_MENU_H
#define __EBI_MENU_H

#include "ebi_config.h"

__EBI_BEGIN_NAMESPACE

class Menu
{
 public:
  Menu ();
  virtual ~Menu ();

  static bool open ();
  static W select ();

 private:
  enum
  {
    MENU_VOBJ,
    MENU_TOOL,
    MENU_EXEC,
    MENU_EXIT,
    MENU_FULLVIEW,
    MENU_REDISP,
    MENU_WORDSEARCH,
    MENU_MENUSEARCH,
    MENU_COPYRIGHT,
    MENU_SUBBOOKTITLE,
    MENU_PREVPAGE,
    MENU_NEXTPAGE,
#if 0
    MENU_FORWARDPAGE,
    MENU_BACKWARDPAGE,
#endif
    MAX_MENU,
  };

  static FUNCP s_funcs[MAX_MENU];

  static W getInterNo (W index);
  static W getActMask (W index);
  static W onTool (W para);
  static W onExit (W para);
  static W onFullview (W para);
  static W onRedisp (W para);
  static W onWordSearch (W para);
  static W onMenuSearch (W para);
  static W onCopyright (W para);
  static W onSubbookTitle (W para);
  static W onPrevPage (W para);
  static W onNextPage (W para);
#if 0
  static W onForwardPage (W para);
  static W onBackwardPage (W para);
#endif
};
  
__EBI_END_NAMESPACE

#endif /* __EBI_MENU_H */
