/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#include "ebi_panel.h"
#include "databox.h"

__EBI_BEGIN_NAMESPACE

Panel::Panels Panel::s_panels;

Panel::Panel (W pnid)
{
  m_pnid = pnid;
}

Panel::~Panel ()
{
}

bool Panel::onBeforeCreate ()
{
  return true;
}

bool Panel::onInitialize ()
{
  return true;
}

void Panel::onRedisp ()
{
}

W Panel::onCommand (W ino, W value)
{
  return -1;
}

W Panel::panelFunc (W pnid, W ino, W value)
{
  Panel* panel = s_panels.top ();
  W ret = -1;
  switch (ino)
    {
    case -1: /*  */
      if (!panel->onBeforeCreate ())
	{
	  ret = 0x8000;
	}
      break;

    case 0: /*  */
      if (!panel->onInitialize ())
	{
	  ret = 0x8000;
	}
      break;

    case -2: /* ɽ */
      panel->onRedisp ();
      break;

    default:
      ret = panel->onCommand (ino, value);
      break;
    }

  return ret;
}

W Panel::doPanel ()
{
  s_panels.push (this);
  W ino = dostdpnl (m_pnid, (FUNCP) panelFunc);
  s_panels.pop ();

  if (ino < 0)
    {
      errpanel (ER_CREATE_PANEL, ino);
    }

  return ino;
}

__EBI_END_NAMESPACE
