/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_PANEL_H
#define __EBI_PANEL_H

#include "ebi_config.h"

__EBI_BEGIN_NAMESPACE

class Panel
{
 public:
  Panel (W pnid);
  virtual ~Panel ();

  W doPanel ();

 protected:
  virtual bool onBeforeCreate ();
  virtual bool onInitialize ();
  virtual void onRedisp ();
  virtual W onCommand (W ino, W value);

 private:
  W m_pnid;
  typedef std::stack<Panel*> Panels;
  static Panels s_panels;

  static W panelFunc (W pnid, W ino, W value);
};

__EBI_END_NAMESPACE

#endif /* __EBI_PANEL_H */
