/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_REFERENCE_H
#define __EBI_REFERENCE_H

#include "ebi_config.h"
#include "ebi_container.h"
#include "ebi_subbook.h"

__EBI_BEGIN_NAMESPACE

class Subbook;
class Page;

class Reference : public Container
{
 public:
  Reference (Subbook* subbook);
  virtual ~Reference ();

  virtual void draw (Device* device, W low, W high);
  virtual const Reference* getReference (const PNT& pnt) const;
  virtual Page* execute () const = 0;
  Subbook* getSubbook () const;
  void getPos (EB_Position* pos) const;
  void setPos (const EB_Position & pos);
  bool isValid () const;

 private:
  Subbook* m_subbook;
  EB_Position m_pos;
};

__EBI_END_NAMESPACE

#endif /* __EBI_REFERENCE_H */
