/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#include "ebi_subbook.h"
#include "ebi_book.h"

__EBI_BEGIN_NAMESPACE

Subbook::Subbook (Book* book, EB_Subbook_Code subbook)
{
  m_book = book;
  m_subbook = subbook;
  m_haveCopyright = false;
  m_haveMenu = false;

  book->getSubbookTitle (m_subbook, &m_title);
  if (book->selectSubbook (m_subbook))
    {
      m_haveCopyright = book->haveCopyright ();
      m_haveMenu = book->haveMenu ();
    }
}

Subbook::~Subbook ()
{
}

Book* Subbook::getBook () const
{
  return m_book;
}

EB_Subbook_Code Subbook::getSubbook () const
{
  return m_subbook;
}

const String& Subbook::getTitle () const
{
  return m_title;
}

bool Subbook::haveCopyright () const
{
  return m_haveCopyright;
}

bool Subbook::haveMenu () const
{
  return m_haveMenu;
}

__EBI_END_NAMESPACE
