/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#include "ebi_textlink.h"
#include "ebi_device.h"
#include "ebi_textpage.h"
#include "ebi_book.h"

__EBI_BEGIN_NAMESPACE

TextLink::TextLink (Subbook* subbook)
  : Reference (subbook)
{
}

TextLink::~TextLink ()
{
}

Page* TextLink::execute () const
{
  EB_Position pos;
  getPos (&pos);
  TextPage* page = new TextPage (getSubbook (), &pos);
  if (!getSubbook ()->getBook ()->getTextPage (pos, page))
    {
      delete page;
      page = NULL;
    }
  return page;
}

__EBI_END_NAMESPACE
