/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_WAVE_H
#define __EBI_WAVE_H

#include "ebi_config.h"

__EBI_BEGIN_NAMESPACE

class Wave
{
 public:
  typedef enum
    {
      FORM_PCM,
      FORM_LAW,
    }
  FormatID;

  Wave ();
  virtual ~Wave ();

  void clear ();
  bool addBinary (const char* binary, UW length);
  bool isValid () const;
  bool getPcmMode (SDPcmMode* mode) const;
  const char* getData (int* length) const;

 private:
  char* m_binary;
  UW m_length;
};

__EBI_END_NAMESPACE

#endif /* __EBI_WAVE_H */
